// pcr1000.cpp: implementation of the pcr1000 class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _MSC_
#include "stdafx.h"
#include "pcrControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#endif

#include "pcr1000.h"
#include "terminalIO.h"
#include "pcrdefs.h"

#include <stdio.h>
#include <assert.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

pcr1000::pcr1000(const char *const ttyname)
{
	m_tty = new terminalIO(ttyname);
	if (m_tty) {
	  init_radio();
	} else {
	  fprintf(stderr,"foo\n");
	  //	  throw aFit();
	}
	  
}

pcr1000::~pcr1000()
{
	delete m_tty;
}

// private helper functions

/*
 * This routine does the hard work of establishing contact with
 * the radio. The radio may have been left in just about any state
 * by the last user (or may not even be present) so try to read
 * it at various baud rates until you get a good response.
 *
 * Once communication is established, set parameters to default
 * values. Return when this is done.
 */

void pcr1000::init_radio(void) {
  m_autoUpdate = false;
  m_AGC = false;
  m_Attenuation = false;
  m_bandscope = false;
  m_DSPInstalled = false;
  m_NB = false;
  m_poll = false;
  m_pollMode = false;
  m_power = false;
  m_status = false;
  m_squelchStatus = false;
  m_VSC = false;
  m_BFO = 0;
  m_DTMFTone = 0;
  m_IFShift = 0;
  m_squelch = 0;
  m_volume = 0;
  m_SamplingRate = 0;
  m_SamplingWidth = 0;
  m_signalCentering = 0;
  m_signalStrength = 0;
  m_toneSquelch = 0;
  m_regionCode = 0;

  m_CenterFrequency = 0.0;
  m_frequency = 0.0;

  m_decodeMode = 0;
  m_filterMode = 0;

  m_baudRate = 0;

  // do the real work here
}

// accessor functions
bool pcr1000::anf(void) const { return false; }
bool pcr1000::autoUpdate(void) const { return false; }
bool pcr1000::bandscopeActive(void) const { return false; }
bool pcr1000::commandStatus(void) const { return false; }
bool pcr1000::dspON(void) const { return false; }
bool pcr1000::isAGCOn(void) const { return false; }
bool pcr1000::isAttenuationOn(void) const { return false; }
bool pcr1000::isDSPInstalled(void) const { return false; }
bool pcr1000::isLinearPowerOn(void) const { return false; }
bool pcr1000::isNBOn(void) const { return false; }
bool pcr1000::isVSCOn(void) const { return false; }
bool pcr1000::updateAscii(void) const { return false; }

Value pcr1000::bandscopeSamplingWidth(void) const { return 0; }
Value pcr1000::bandscopeSamplingRate(void) const { return 0; }
Value pcr1000::bfo(void) const { return 0; }
Value pcr1000::DTMFTone(void) const { return 0; }
Value pcr1000::IFShift(void) const { return 0; }
Value pcr1000::noiseReductionLevel(void) const { return 0; }
Value pcr1000::signalStrength(void) const { return 0; }
Value pcr1000::signalCentering(void) const { return 0; }
Value pcr1000::squelch(void) const { return 0; }
Value pcr1000::toneSquelch(void) const { return 0; }
Value pcr1000::volume(void) const { return 0; }

const Value * const pcr1000::samples(int window) const { return 0; }

const char * const pcr1000::regionCode(void) const { return 0; }
const char * const pcr1000::protocol(void) const { return 0; }

double pcr1000::bandscopeCenterFrequency(void) const { return 0; }
double pcr1000::frequency(void) const { return 0; }

int pcr1000::baudRate(void) const { return 0;}
int pcr1000::decodeMode(void) const { return 0; }
int pcr1000::filterMode(void) const { return 0; }
int pcr1000::scanStatus(void) const { return 0; }

// mutator functions

void pcr1000::AGC(bool newMode) { }
void pcr1000::anf(bool onOff) { }
void pcr1000::attenuation(bool newMode) { }
void pcr1000::autoUpdate(bool newMode) { }
void pcr1000::baudRate(int rate) { }
void pcr1000::bfo(Value rate) { }
void pcr1000::bandscope(bool onOff) { }
void pcr1000::bandscopeCenterFrequency(double newFrequency) { }
void pcr1000::bandscopeSamplingRate(Value newSamplingRate) { }
void pcr1000::bandscopeSamplingWidth(Value newSamplingWidth) { }
void pcr1000::decodeMode(int newMode) { }
void pcr1000::dsp(bool newMode) { }
void pcr1000::filterWidth(int newMode) { }
void pcr1000::frequency(double newFrequency) { }
void pcr1000::IFShift(Value newIFShift) { }
void pcr1000::linearPower(bool onOff) { }
void pcr1000::NB(bool newMode) { }
void pcr1000::noiseReductionLevel(Value newMode) { }
void pcr1000::poll(bool newMode) { }
void pcr1000::pollAscii(bool newMode) { }
void pcr1000::reset(void) { }
void pcr1000::squelch(Value newSquelch) { }
void pcr1000::toneSquelch(Value newToneSquelch) { }
void pcr1000::volume(Value newVolume) { }
void pcr1000::VSC(bool newMode) { }
