#include "terminalIO.h"
#include "ttyio.h"

terminalIO::terminalIO(const char * const tty_name)
{
  int temprate;
  m_fd = open_pcr1000(tty_name);
  // throw here
  if (m_fd >= 0) {
    get_baudrate_pcr1000(&m_baudrate, &temprate);
  }
}

terminalIO::~terminalIO()
{
  if (m_fd >= 0) {
    close_pcr1000();
  }
}

int terminalIO::baudrate(void) const {
  return m_baudrate;
}

void terminalIO::baudrate(int newRate) {
  int error = set_baudrate_pcr1000(newRate, newRate);
  if (!error) {
    m_baudrate = newRate;
  }
}
  
int terminalIO::bytes(void) {
  return m_bytes;
}

#define MAXBYTES 80

char * terminalIO::get_bytes(void) {
  char *buffer = new char[MAXBYTES];
  m_bytes = get_bytes_pcr1000(buffer, MAXBYTES);
  return buffer;
}

void terminalIO::put_bytes(const char * const buffer, int nbytes) {
  put_bytes_pcr1000(buffer, nbytes);
}


